
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Cellpose &#8212; seg_compare 0.0.1 documentation</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">seg_compare 0.0.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Cellpose</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="cellpose">
<h1>Cellpose<a class="headerlink" href="#cellpose" title="Permalink to this headline">¶</a></h1>
<ul class="simple">
<li><p><b> Original repository </b>: <a href="https://github.com/MouseLand/cellpose"> https://github.com/MouseLand/cellpose </a></p></li>
<li><p><b> License </b> : BSD 3-Clause</p></li>
<li><p><b> Paper citation </b> : <i>Stringer C, Wang T, Michaelos M, Pachitariu M. Cellpose: a generalist algorithm for cellular segmentation. Nat Methods. 2021;18: 100–106. doi:10.1038/s41592-020-01018-x </i></p></li>
<li><p><b>Concept</b>: An end-to-end deep learning pipeline which can be trained with 2D images but can perform 3D instance segmentation. It uses a residual 2D-UNet architecture along with image gradient estimations for instance segmentation.</p></li>
</ul>
<div align="center">
<img src="../_static/cp_pipeline.png" alt="Cellpose pipeline" width="1000" height="250"/>
<figcaption>Schematic diagram of the Cellpose pipeline</figcaption>
</div>
<div class="section" id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Permalink to this headline">¶</a></h2>
<ol>
<li><p>Open a terminal and clone the cellpose repository at <a href="https://github.com/MouseLand/cellpose">  https://github.com/MouseLand/cellpose </a> using:</p>
<p><code class="docutils literal notranslate"><span class="pre">git</span> <span class="pre">clone</span> <span class="pre">https://github.com/MouseLand/cellpose.git</span></code></p>
</li>
<li><p>Navigate to the <code class="docutils literal notranslate"><span class="pre">cellpose</span></code> folder and download the <a href="https://gitlab.inria.fr/mosaic/publications/seg_compare/-/tree/master/envs/cellpose_env.yaml">  cellpose_env.yaml </a> file (<b>envs/</b> in the <a href="https://gitlab.inria.fr/mosaic/publications/seg_compare">  GitLab</a>) inside the folder.</p></li>
<li><p>Make sure you are in the <code class="docutils literal notranslate"><span class="pre">cellpose</span></code> folder and create a new environment:</p>
<p><code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">env</span> <span class="pre">create</span> <span class="pre">-f</span> <span class="pre">cellpose_env.yaml</span></code></p>
</li>
<li><p>Activate the environment:</p>
<p><code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">activate</span> <span class="pre">cellpose</span></code></p>
</li>
<li><p>Install the GPU version of MKL library:</p>
<p><code class="docutils literal notranslate"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">mxnet-cu101==version</span></code></p>
</li>
</ol>
<p>Note: Check the MKL version required for your computer at  <a href="https://mxnet.apache.org/versions/1.7.0/get_started?">  https://mxnet.apache.org/versions/1.7.0/get_started? </a></p>
</div>
<div class="section" id="uses">
<h2>Uses<a class="headerlink" href="#uses" title="Permalink to this headline">¶</a></h2>
<p>The segmentation of an image using Cellpose method requires a trained model. This model can be obtained in two different ways:</p>
<ul class="simple">
<li><p>Download one of the proposed <a href="https://doi.org/10.6084/m9.figshare.14433590.v1">  trained models </a></p></li>
<li><p>Train your own model using either your data or the proposed <a href="https://www.repository.cam.ac.uk/handle/1810/262530 "> training data  </a> (see <a class="reference internal" href="dataset.html"><span class="doc std std-doc">Datasets</span></a>).</p></li>
</ul>
<p><b>Train your own model</b></p>
<ul>
<li><p><b>Dataset preparation</b>: The training data can be prepared using 2D image and corresponding ground truth slices from the training dataset. The training filenames are formatted as</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>      `wells_000.tif  wells_000_masks.tif`
</pre></div>
</div>
</li>
<li><p><b>Training environment</b>: Invoke the training environment using :</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>`conda activate cellpose`. 
</pre></div>
</div>
</li>
<li><p><b>Model training</b>: Training can be invoked by the following command:</p>
<p><code class="docutils literal notranslate"><span class="pre">python</span> <span class="pre">-m</span> <span class="pre">cellpose</span> <span class="pre">--train</span> <span class="pre">--dir</span>&#160; <span class="pre">&lt;PATH</span> <span class="pre">TO</span> <span class="pre">TRAINING</span> <span class="pre">DATA</span> <span class="pre">FOLDER&gt;</span> <span class="pre">--pretrained_model</span> <span class="pre">None</span> <span class="pre">--use_gpu</span> <span class="pre">--n_epochs</span> <span class="pre">1000</span></code></p>
</li>
</ul>
<p><b>Use a model</b></p>
<ul>
<li><p><b>Post-processing</b>: None. Prediction of trained model on a test image can be invoked within the environment by:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>  `python -m cellpose --dir &lt;PATH TO TEST DATA FOLDER&gt;  --pretrained_model &lt;PATH TO TRAINED MODEL FILE&gt;  --save_tif --do_3D --use_gpu --no_npy --diameter 50.0`
</pre></div>
</div>
</li>
</ul>
</div>
<div class="section" id="results">
<h2>Results<a class="headerlink" href="#results" title="Permalink to this headline">¶</a></h2>
<p>You can find sample segmentation results and ground truth at this <a href="https://doi.org/10.6084/m9.figshare.14447079.v1">  link </a>.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Cellpose</a><ul>
<li><a class="reference internal" href="#installation">Installation</a></li>
<li><a class="reference internal" href="#uses">Uses</a></li>
<li><a class="reference internal" href="#results">Results</a></li>
</ul>
</li>
</ul>

  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/descriptions/cp_pipeline.md.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="nav-item nav-item-0"><a href="../index.html">seg_compare 0.0.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Cellpose</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Anuradha Kar.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 3.2.1.
    </div>
  </body>
</html>